// Generated by LiveScript 1.4.0
var ref$, cyan, green, red, inquirer, fs, yaml, Logger, version, path, tmplconv, questions;
ref$ = require('chalk'), cyan = ref$.cyan, green = ref$.green, red = ref$.red;
inquirer = require('inquirer');
fs = require('fs');
yaml = require('js-yaml');
Logger = require('../../logger');
version = require('../../../package.json').version;
path = require('path');
tmplconv = require('tmplconv');
console.log('We are about to add a new Exosphere service to the application!\n');
questions = [
  {
    message: 'Name of the service to create:',
    type: 'input',
    name: 'service-name',
    filter: function(input){
      return input.trim();
    },
    validate: function(input){
      return input.length > 0;
    }
  }, {
    message: 'Description:',
    type: 'input',
    name: 'description',
    filter: function(input){
      return input.trim();
    }
  }, {
    message: 'Type:',
    type: 'list',
    name: 'template-name',
    choices: serviceNames()
  }
];
inquirer.prompt(questions).then(function(answers){
  var srcPath, targetPath, appConfig;
  srcPath = path.join(__dirname, '..', '..', '..', 'templates', 'add-service', answers['template-name']);
  targetPath = path.join(__dirname, '..', '..', '..', 'tmp', answers['service-name']);
  appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
  answers['app-name'] = appConfig.name;
  console.log(answers);
  console.log();
  return tmplconv.render(srcPath, targetPath, {
    data: answers
  }).then(function(){
    return console.log(green("\ndone"));
  });
});
function serviceNames(){
  return fs.readdirSync(path.join(__dirname, '..', '..', '..', 'templates', 'add-service'));
}