// Generated by LiveScript 1.4.0
var EventEmitter, fs, yaml, ObservableProcess, path, ServiceInstaller;
EventEmitter = require('events').EventEmitter;
fs = require('fs');
yaml = require('js-yaml');
ObservableProcess = require('observable-process');
path = require('path');
ServiceInstaller = (function(superclass){
  var prototype = extend$((import$(ServiceInstaller, superclass).displayName = 'ServiceInstaller', ServiceInstaller), superclass).prototype, constructor = ServiceInstaller;
  function ServiceInstaller(name, config){
    this.name = name;
    this.config = config;
    this._log = bind$(this, '_log', prototype);
    this.start = bind$(this, 'start', prototype);
    this.serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(this.config.root, 'config.yml'), 'utf8'));
  }
  prototype.start = function(done){
    var this$ = this;
    this.emit('start', this.name);
    return new ObservableProcess(this.serviceConfig.setup, {
      cwd: this.config.root,
      verbose: true,
      console: {
        log: this._log,
        error: this._log
      },
      onExit: function(){
        this$.emit('finished', this$.name);
        return done();
      }
    });
  };
  prototype._log = function(text){
    return this.emit('output', {
      name: this.name,
      text: text
    });
  };
  return ServiceInstaller;
}(EventEmitter));
module.exports = ServiceInstaller;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}