// Generated by LiveScript 1.4.0
var AppRunner, ref$, bold, cyan, dim, green, red, yaml, Logger, fs, version, util, appConfig, logger, x$, appRunner;
AppRunner = require('./app-runner');
ref$ = require('chalk'), bold = ref$.bold, cyan = ref$.cyan, dim = ref$.dim, green = ref$.green, red = ref$.red;
yaml = require('js-yaml');
Logger = require('../../logger');
fs = require('fs');
version = require('../../../package.json').version;
util = require('util');
console.log(dim("Exosphere SDK " + version + "\n"));
appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
console.log("Running " + green(appConfig.name) + " " + cyan(appConfig.version) + "\n");
logger = new Logger(Object.keys(appConfig.services));
x$ = appRunner = new AppRunner(appConfig);
x$.on('error', function(err){
  return console.log(red(error));
});
x$.on('output', function(data){
  return logger.log(data);
});
x$.on('exocom-online', function(port){
  return logger.log({
    name: 'exocom',
    text: "online at port " + port
  });
});
x$.on('service-online', function(name){
  return logger.log({
    name: 'exorun',
    text: "'" + name + "' is running using exorelay port " + appRunner.portFor(name)
  });
});
x$.on('routing-setup', function(){
  var command, ref$, routing, text, receivers, res$, i$, ref1$, len$, receiver, results$ = [];
  logger.log({
    name: 'exocom',
    text: 'received routing setup'
  });
  for (command in ref$ = appRunner.exocom.clientRegistry.routes) {
    routing = ref$[command];
    text = "  [ " + bold(command) + " ]  -->  ";
    res$ = [];
    for (i$ = 0, len$ = (ref1$ = routing.receivers).length; i$ < len$; ++i$) {
      receiver = ref1$[i$];
      res$.push(bold(receiver.name) + " (" + receiver.host + ":" + receiver.port + ")");
    }
    receivers = res$;
    text += receivers.join(' & ');
    results$.push(logger.log({
      name: 'exocom',
      text: text
    }));
  }
  return results$;
});
x$.on('message', function(arg$){
  var messages, receivers, message, indent, i$, ref$, len$, line, results$ = [];
  messages = arg$.messages, receivers = arg$.receivers;
  message = messages[0];
  if (message.name !== message.originalName) {
    logger.log({
      name: 'exocom',
      text: bold(message.sender) + "  --[ " + bold(message.originalName) + " ]-[ " + bold(message.name) + " ]->  " + bold(receivers.join(' and '))
    });
  } else {
    logger.log({
      name: 'exocom',
      text: bold(message.sender) + "  --[ " + bold(message.name) + " ]->  " + bold(receivers.join(' and '))
    });
  }
  indent = repeatString$(' ', message.sender.length + 2);
  if (message.payload != null) {
    for (i$ = 0, len$ = (ref$ = util.inspect(message.payload, {
      showHidden: false,
      depth: null
    }).split('\n')).length; i$ < len$; ++i$) {
      line = ref$[i$];
      results$.push(logger.log({
        name: 'exocom',
        text: indent + "" + dim(line),
        trim: false
      }));
    }
    return results$;
  } else {
    return logger.log({
      name: 'exocom',
      text: indent + "" + dim('(no payload)'),
      trim: false
    });
  }
});
x$.startExocom();
x$.startServices();
x$.on('all-services-online', function(){
  var x$;
  logger.log({
    name: 'exorun',
    text: 'all services online'
  });
  x$ = appRunner;
  x$.on('routing-done', function(){
    return logger.log({
      name: 'exorun',
      text: "application ready"
    });
  });
  x$.sendServiceConfiguration();
  return x$;
});
function repeatString$(str, n){
  for (var r = ''; n > 0; (n >>= 1) && (str += str)) if (n & 1) r += str;
  return r;
}