// Generated by LiveScript 1.4.0
var EventEmitter, yaml, fs, N, portReservation, ObservableProcess, path, ServiceRunner;
EventEmitter = require('events').EventEmitter;
yaml = require('js-yaml');
fs = require('fs');
N = require('nitroglycerin');
portReservation = require('port-reservation');
ObservableProcess = require('observable-process');
path = require('path');
ServiceRunner = (function(superclass){
  var prototype = extend$((import$(ServiceRunner, superclass).displayName = 'ServiceRunner', ServiceRunner), superclass).prototype, constructor = ServiceRunner;
  function ServiceRunner(name, config){
    this.name = name;
    this.config = config;
    this._log = bind$(this, '_log', prototype);
    this.start = bind$(this, 'start', prototype);
    this.serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(this.config.root, 'config.yml'), 'utf8'));
  }
  prototype.start = function(done){
    var this$ = this;
    return portReservation.getPort(N(function(port){
      var x$;
      this$.config.SERVICE_NAME = this$.name;
      this$.config.EXORELAY_PORT = port;
      x$ = new ObservableProcess(this$._createCommand(this$.serviceConfig.startup.command), {
        cwd: this$.config.root,
        env: this$.config,
        verbose: true,
        console: {
          log: this$._log,
          error: this$._log
        }
      });
      x$.wait(this$.serviceConfig.startup['online-text'], function(){
        this$.emit('online', this$.name);
        return done();
      });
      return x$;
    }));
  };
  prototype._createCommand = function(template){
    var key, ref$, value;
    template = this.config.root + "/" + template;
    for (key in ref$ = this.config) {
      value = ref$[key];
      template = template.replace("{{" + key + "}}", value);
    }
    return template;
  };
  prototype._log = function(text){
    return this.emit('output', {
      name: this.name,
      text: text
    });
  };
  return ServiceRunner;
}(EventEmitter));
module.exports = ServiceRunner;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}